use std::any::{TypeId, type_name};
//* # See what's behind the primitive datatypes of Rust
//*
//* This Crate shows off, how primitive Types of rust are stored in memory.

fn main() {
    println!("bool");
    let mut items = Vec::new();
    items.push(true);
    items.push(false);
    unsafe {
        for (index, item) in items.iter().enumerate() {
            let mem_item: [u8; 1] = std::mem::transmute(*item);
            let ref_item: [u8; 8] = std::mem::transmute(item);
            println!("\t{index:02x}\titem:\t{item}\n\
                \t\tmemory: {:X?}\n\n\
                \t\tlocal ref: {:X?}",
                mem_item,
                ref_item,
            );
        }
    }
}

fn dump_type<T: 'static>() {
    println!("{:?}", TypeId::of::<T>());
    let mut items = Vec::new();
    items.push(true);
    items.push(false);
    unsafe {
        for (index, item) in items.iter().enumerate() {
            let mem_item: [u8; 1] = std::mem::transmute(*item);
            let ref_item: [u8; 8] = std::mem::transmute(item);
            println!("\t{index:02x}\titem:\t{item}\n\
                \t\tmemory: {:X?}\n\n\
                \t\tlocal ref: {:X?}",
                mem_item,
                ref_item,
            );
        }
    }
}
